shader_type canvas_item;
render_mode blend_premul_alpha,unshaded;

uniform sampler2D iChannel0;

// https://www.shadertoy.com/view/llfyz4

const float pi=3.1415926;
    

vec3 toRGB(vec3 ybr)
{
    return (ybr-vec3(0,.5,.5))*mat3(vec3(1.,0.,1.402),vec3(1.,-.344136,-0.714136),vec3(1.,1.772,0.));
}

vec3 inp(vec2 coord){
    return texelFetch(iChannel0, ivec2(coord),0).xyz;
}

vec3 IDCT8x8( vec2 coord, vec2 xy ) {
    vec3 res = vec3(0);
    for(float u = 0.; u < 8.; u++){
    	for(float v = 0.; v < 8.; v++){
            res += inp(coord + vec2(u,v)) *
                (u!=0.?1.:1./sqrt(2.)) * (u!=0.?1.:1./sqrt(2.)) * 
                cos((2.*xy.x+1.)*u*pi/16.) * 
                cos((2.*xy.y+1.)*v*pi/16.); 
    	}
    }
    return res * .25;
}


void mainImage( out vec4 fragColor, in vec2 fragCoord, vec2 iResolution )
{
    fragColor.w = 1.;
    vec2 uv = floor(fragCoord-8.*floor(fragCoord/8.));
        fragColor.xyz = toRGB(IDCT8x8(8.*floor(fragCoord/8.),uv)/256.+.5);
}


void fragment(){
    vec2 iResolution=1./TEXTURE_PIXEL_SIZE;
    mainImage(COLOR,FRAGCOORD.xy,iResolution);
    COLOR.rgb=COLOR.rgb;
    if(UV.x<0.5){
      COLOR=textureLod(TEXTURE,UV,0.);
    } //else COLOR=textureLod(iChannel0,UV,0.);
      
}
