shader_type spatial;
render_mode blend_mix,depth_draw_opaque,cull_back,diffuse_burley,specular_schlick_ggx,unshaded;

uniform sampler2D my_screen_texture:hint_albedo;
uniform int iFrame;

vec3 decodeSRGB(vec3 screenRGB)
{
    vec3 a = screenRGB / 12.92;
    vec3 b = pow((screenRGB + 0.055) / 1.055, vec3(2.4));
    vec3 c = step(vec3(0.04045), screenRGB);
    return mix(a, b, c);
}

void fragment(){
	
  vec2 tuv=UV;
  tuv.y=1.-tuv.y;
	vec3 screen_color=texture(my_screen_texture,tuv).rgb;
	
	ALBEDO = decodeSRGB(screen_color);
}
